<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* Xentral (c) Xentral ERP Sorftware GmbH, Fuggerstrasse 11, D-86150 Augsburg, * Germany 2019
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php
include ("_gen/vorlage.php");

//class Verbindlichkeiten Extends GenVorlage {
class Verbindlichkeit Extends GenVorlage {
  var $app;

  // http://192.168.2.125/www/index.php?module=verbindlichkeiten&action=list

  static function GetSrc($app, $name)
  {
    $res = "src=\"themes/";
    $res .= $app->Conf->WFconf['defaulttheme'];
    $res .= "/images/";
    $res .= $name;
    $res .= ".svg\"";
    return $res;
  }

  static function GetImgSrc($app, $name)
  {
    $res = "<img ";
    $res .= Verbindlichkeit::GetSrc($app, $name);
    $res .= " border=\"0\">";
    return $res;
  }

  /*
  static function GetImgSrc($app, $name)
  {
    $res = "<img src=\"themes/";
    $res .= $app->Conf->WFconf['defaulttheme'];
    $res .= "/images/";
    $res .= $name;
    $res .= ".svg\" border=\"0\">";
    return $res;
  }
  */

  static function TableSearch(&$app, $name, $erlaubtevars)
  {
    // in dieses switch alle lokalen Tabellen (diese Live Tabellen mit Suche etc.) für dieses Modul
    //tail -f /var/log/apache2/error.log

    //error_log("Verbinlichkeiten::TableSearch: '$name'",0);

    switch($name)
    {
      case "verbindlichkeit_list":
        // angeben welches recht der Benutzer braucht damit er auf diese tabelle zugreifen darf
        $allowed['verbindlichkeiten'] = array('list');

        //$heading = array('Nummer','Datum','Projekt','Men&uuml;');
        $heading =
        array('Name','Kundennummer','Lieferantennummer','Nummer','Datum','Betrag', 'Projekt','Men&uuml;');
        $width = array('30%','10%','10%','10%','15%','15%','5%','5%');

        $findcols = array('a.name','a.kundennummer','a.lieferantennummer', 'v.rechnung', "v.rechnungsdatum", 'v.betragbezahlt', 'p.abkuerzung', 'v.id');

        $searchsql = array('a.name','a.kundennummer','a.lieferantennummer','v.rechnung', "DATE_FORMAT(v.rechnugsdatum,'%d.%m.%Y')",'v.betragbezahlt','p.abkuerzung');

        $defaultorder = 1; //Optional wenn andere Reihenfolge gewuenscht
        $defaultorderdesc = 1;

        //$menu = "<a href=\"index.php?module=vorlage&action=edit&id=%value%\"><img src=\"themes/{$app->Conf->WFconf['defaulttheme']}/images/edit.svg\" border=\"0\"></a>&nbsp;<a href=\"index.php?module=vorlage&action=edit&id=%value%\"><img src=\"themes/{$app->Conf->WFconf['defaulttheme']}/images/delete.svg\" border=\"0\"></a>&nbsp;<a href=\"index.php?module=verbindlichkeit&action=pdf&id=%value%\"><img border=\"0\" src=\"./themes/new/images/pdf.svg\" title=\"PDF\"></a>"; 

        $menu = "<table cellpadding=0 cellspacing=0><tr><td nowrap>" .
          "<a href=\"index.php?module=verbindlichkeit&action=edit&id=%value%\">".

            Verbindlichkeit::GetImgSrc($app, "edit").

            "</a>".
            "&nbsp;".
            "<a href=\"index.php?module=vorlage&action=edit&id=%value%\">".

            Verbindlichkeit::GetImgSrc($app, "delete").

            "</a>".
            "&nbsp;".
            "<a href=\"index.php?module=verbindlichkeit&action=pdf&id=%value%\">".
            "<img border=\"0\" ".

            Verbindlichkeit::GetSrc($app, "pdf").

            " title=\"PDF\"></a>" . 
          "</td></tr></table>";
        //$menucol = 4;
        //$moreinfo = true;
        //$sumcol = 9;

        $where = " v.id > 0 ";


        /*
        $sql = "SELECT SQL_CALC_FOUND_ROWS v.id, v.rechnung, DATE_FORMAT(v.rechnungsdatum,'%d.%m.%Y'), p.abkuerzung, v.id
          FROM verbindlichkeit v LEFT JOIN projekt p ON v.projekt = p.id ";
        */
        $sql = "SELECT SQL_CALC_FOUND_ROWS v.id, a.name, a.kundennummer, a.lieferantennummer, v.rechnung, DATE_FORMAT(v.rechnungsdatum,'%d.%m.%Y'), v.betragbezahlt, p.abkuerzung, v.id FROM verbindlichkeit v LEFT JOIN projekt p ON v.projekt = p.id LEFT JOIN adresse a ON v.adresse = a.id";

        //echo($sql);
        $count = "SELECT count(v.id) FROM verbindlichkeit v LEFT JOIN projekt p ON v.projekt = p.id WHERE $where"; 
      break;
      case "my_positionen_list":
        $id = $app->Secure->GetGET('id');
        // angeben welches recht der Benutzer braucht damit er auf diese tabelle zugreifen darf
        //$allowed['verbindlichkeiten'] = array('list');

        //$heading = array('Nummer','Datum','Projekt','Men&uuml;');
        $heading = array('Menge','Bezeichnung','Preis','Men&uuml;');

        $width = array('10%', '70%','10%','10%');

        $findcols = array('p.menge','p.bezeichnung','p.preis', 'p.id');

        $searchsql = array('p.menge','p.bezeichnung','p.preis', 'p.id');

        $defaultorder = 1; //Optional wenn andere Reihenfolge gewuenscht
        $defaultorderdesc = 1;

        $menu = "<table cellpadding=0 cellspacing=0><tr><td nowrap>" .
          "<a href=\"index.php?module=verbindlichkeit_positionen&action=edit&id=%value%\">".

            Verbindlichkeit::GetImgSrc($app, "edit").

            "</a>".
            "&nbsp;".
            "<a href=\"index.php?module=vorlage&action=edit&id=%value%\">".

            Verbindlichkeit::GetImgSrc($app, "delete").

            "</a>".
          "</td></tr></table>";
        //$menucol = 4;
        //$moreinfo = true;
        //$sumcol = 9;

        error_log("Verbindlichkeit::TableSearch: id '".$id."'",0);
        $where = " p.verbindlichkeit = $id";


        /*
        $sql = "SELECT SQL_CALC_FOUND_ROWS v.id, v.rechnung, DATE_FORMAT(v.rechnungsdatum,'%d.%m.%Y'), p.abkuerzung, v.id
          FROM verbindlichkeit v LEFT JOIN projekt p ON v.projekt = p.id ";
        */
        $sql = "SELECT SQL_CALC_FOUND_ROWS p.id, p.menge,
          p.bezeichnung, p.preis FROM verbindlichkeit_position p ";

       
        //echo($sql);
        $count = "SELECT count(p.id) FROM verbindlichkeit_position p WHERE $where"; 
        //echo($count);
      break;
    }

    $erg = false;

    foreach($erlaubtevars as $k => $v)
    {
      if(isset($$v))$erg[$v] = $$v;
    }
    return $erg;
  }


  function __construct($app, $intern = false) {
    $this->app=$app;
    if($intern)return;
    $this->app->ActionHandlerInit($this);

    // ab hier alle Action Handler definieren die das Modul hat
    $this->app->ActionHandler("list", "VerbindlichkeitenList");
    //$this->app->ActionHandler("create", "VerbindlichkeitenCreate");
    $this->app->ActionHandler("create", "VerbindlichkeitenEdit"); // This automatically adds a "New" button
    $this->app->ActionHandler("pdf","VerbindlichkeitenPDF"); 
    $this->app->ActionHandler("edit", "VerbindlichkeitenEdit");
    $this->app->ActionHandler("pdf", "VerbindlichkeitenPDF");
    //$this->app->ActionHandler("pos_list", "PositionenList");
    $this->app->ActionHandler("positionen","VerbindlichkeitPositionen");
    $this->app->ActionHandler("dateien","AdresseDateien");


    $this->app->ActionHandler("copyverbindlichkeitposition","CopyVerbindlichkeitPosition");
    $this->app->ActionHandler("upverbindlichkeitposition","UpVerbindlichkeitPosition");
    $this->app->ActionHandler("downverbindlichkeitposition","DownVerbindlichkeitPosition");
    $this->app->ActionHandler("delverbindlichkeitposition","DelVerbindlichkeitPosition");
    $this->app->ActionHandler("editable","VerbindlichkeitEditable");

    $this->app->ActionHandlerListen($app);

    $this->Install();
  }

  function Install()
  {
    $this->app->erp->CheckTable("verbindlichkeit");
    $this->app->erp->CheckColumn("id", "int(11)", "verbindlichkeit", "NOT NULL AUTO_INCREMENT");
    $this->app->erp->CheckColumn("rechnung", "varchar(255)", "verbindlichkeit", "NOT NULL DEFAULT ''");
    $this->app->erp->CheckColumn("rechnungsdatum", "DATE", "verbindlichkeit", "NOT NULL");
    $this->app->erp->CheckColumn("projekt", "int(11)", "verbindlichkeit", "NOT NULL DEFAULT '0'");
  }

  function VorlageMenu()
  {
    $this->app->erp->MenuEintrag("index.php?module=verbindlichkeiten&action=list","Zur&uuml;ck zur &Uuml;bersicht");
  }

  function PositionenList()
  {
    //$this->app->Tpl->Set('MESSAGE', "<div class=\"error\">meine Fehlermeldung</div>");
    //$this->app->erp->MenuEintrag("index.php?module=verbindlichkeiten&action=create","Neue Vorlage");
    $this->app->erp->MenuEintrag("index.php?module=verbindlichkeit&action=create", "Neu anlegen");
    $this->app->erp->MenuEintrag("index.php?module=verbindlichkeit&action=list","&Uuml;bersicht");

    $this->app->erp->MenuEintrag("index.php", "Home");

    $this->app->YUI->TableSearch('TAB1','my_positionen_list', "show","","",basename(__FILE__), __CLASS__);

    $this->app->Tpl->Parse("PAGE","verbindlichkeit_positionen_list.tpl");
  }

  function VerbindlichkeitenList()
  {
    //$this->app->Tpl->Set('MESSAGE', "<div class=\"error\">meine Fehlermeldung</div>");
    //$this->app->erp->MenuEintrag("index.php?module=verbindlichkeiten&action=create","Neue Vorlage");
    $this->app->erp->MenuEintrag("index.php?module=verbindlichkeit&action=create", "Neu anlegen");
    $this->app->erp->MenuEintrag("index.php?module=verbindlichkeit&action=list","&Uuml;bersicht");

    $this->app->erp->MenuEintrag("index.php", "Home");

    $this->app->YUI->TableSearch('TAB1','verbindlichkeit_list', "show","","",basename(__FILE__), __CLASS__);

    $this->app->Tpl->Parse("PAGE","verbindlichkeit_list.tpl");
  }

  function VerbindlichkeitenPDF()
  {

    $fid = $this->app->Secure->GetGET('fid');
    $id = $this->app->Secure->GetGET('id');

    $datei_id = $this->app->DB->Select("
      SELECT ds.datei 
      FROM datei_stichwoerter ds 
      WHERE 
          ds.parameter ='$id'
        AND
          ds.objekt = 'verbindlichkeit'
    "); 

    $this->app->erp->SendDatei($datei_id, $fid);
    $this->app->ExitXentral();
  }


  public function DelVerbindlichkeitPosition()
  {
    $sid = (int)$this->app->Secure->GetGET('sid');
    $id = (int)$this->app->Secure->GetGET('id');
    /*
    if($sid > 0){
      $this->DelVerbindlichkeitStueckliste($id, $sid);
    }
    */
    $this->app->YUI->SortListEvent('del','verbindlichkeit_position','verbindlichkeit');
    if($sid > 0)
    /*
    {
      $this->DelVerbindlichkeitStueckliste($id, $sid);
      $this->app->erp->VerbindlichkeitNeuberechnen($id);
    }
    */
    $this->VerbindlichkeitPositionen();
  }
  
  public function CopyVerbindlichkeitPosition()
  {
    $this->app->YUI->SortListEvent('copy','verbindlichkeit_position','verbindlichkeit');
    $this->VerbindlichkeitPositionen();
  }

  public function UpVerbindlichkeitPosition()
  {
    $this->app->YUI->SortListEvent('up','verbindlichkeit_position','verbindlichkeit');
    $this->VerbindlichkeitPositionen();
  }

  public function DownVerbindlichkeitPosition()
  {
    $this->app->YUI->SortListEvent('down','verbindlichkeit_position','verbindlichkeit');
    $this->VerbindlichkeitPositionen();
  }

  function GenerateWord()
  {
    //Get a random word
    $nb=rand(3,10);
    $w='';
    for($i=1;$i<=$nb;$i++)
        $w.=chr(rand(ord('a'),ord('z')));
    return $w;
  }

  function GenerateSentence()
  {
    //Get a random sentence
    $nb=rand(1,10);
    $s='';
    for($i=1;$i<=$nb;$i++)
        $s.=$this->GenerateWord().' ';
    return substr($s,0,-1);
  }

  function VorlagePDF()
  {
    //Create a new PDF file
    $pdf=new SuperFPDF('P','mm','A4',$this->app);
    $pdf->AddPage();
    $pdf->SetFont('Arial','',8);
    //$pdf->WriteHTML("huhu<b>dick</b>"); 
    $pdf->SetTableWidths(array(30,50,30,40));
    $pdf->SetTableFonts(array(array('Arial','',8),array('Arial','',8),array('Arial','',8),array('Arial','',8)));
    srand(microtime()*1000000);
    for($i=0;$i<20;$i++)
      $pdf->TableRow(array($this->GenerateSentence(),$this->GenerateSentence(),$this->GenerateSentence(),$this->GenerateSentence()));

    $pdf->Output(date('Ymd')."_".$name."_ABRECHNEN.pdf",'D');
    exit;

  }



  function AdresseDateien()
  {
    $id = $this->app->Secure->GetGET('id');

    error_log("My_Verbindlichkeitene::AdresseDateieninput::id: '".  $id ."'",0);

    $this->VerbindlichkeitenMenu();
    $this->app->Tpl->Add('UEBERSCHRIFT',' (Dateien)');
    $this->app->YUI->DateiUpload('PAGE','Verbindlichkeit',$id);
  }


  function VerbindlichkeitenMenu()
  {
    $id = $this->app->Secure->GetGET('id');



/*
    $nummer = $this->app->DB->Select("SELECT CONCAT(
        if(kundennummer!='',CONCAT('Kunde: ',kundennummer),''),
          if(lieferantennummer!='',CONCAT(' Lieferant: ',lieferantennummer),'')) FROM adresse WHERE id='$id' AND geloescht=0 LIMIT 1");
*/
    $nummer = $this->app->DB->Select("
      SELECT CONCAT(
        if(a.kundennummer!='',
          CONCAT('Kunde: ',a.kundennummer),
          ''),
        if(a.lieferantennummer!='',
          CONCAT('Lieferant: ',a.lieferantennummer),
          ''))
      FROM adresse a
        LEFT JOIN verbindlichkeit v 
        ON v.adresse = a.id
      WHERE v.id='".$id."' AND a.geloescht=0
      LIMIT 1");

    error_log("My_verbinlichkeiten::VerbindlichkeitenMenu nummer:: '". $nummer."'",0);

    /*
    if(is_numeric($id)){
      $name = $this->app->DB->Select("SELECT name FROM adresse WHERE id='$id' AND geloescht=0 LIMIT 1");
    }
    */

    if(is_numeric($id)){
      $name = $this->app->DB->Select("
        SELECT a.name
        FROM adresse a
        LEFT JOIN verbindlichkeit v
        ON a.id = v.adresse
        WHERE v.id='".$id."' AND a.geloescht=0
        LIMIT 1");
    }

    error_log("My_verbinlichkeiten::VerbindlichkeitenMenu name: '".  $name."'",0);

    if(isset($name) && $name!=''){
      $this->app->Tpl->SetText('UEBERSCHRIFT', 'Verbindlichkeit von: ' . $name);
    }
    else{
      $this->app->Tpl->SetText('UEBERSCHRIFT', 'Verbindlichkeiten');
    }

    $this->app->Tpl->SetText('KURZUEBERSCHRIFT','Verbindlichkeiten ' .  $id);
    if(isset($name) && isset($nummer) && $name!='' && $nummer!=''){
      $this->app->Tpl->SetText('KURZUEBERSCHRIFT2', "$name ($nummer)");
    }
    else{
      $this->app->Tpl->SetText('KURZUEBERSCHRIFT2', !empty($name) ? $name : '');
    }

    if(isset($name)){
      $this->app->Tpl->SetText('ANZEIGENUMMER',$name);
    }

    if(isset($nummer)){
      $this->app->Tpl->SetText('ANZEIGENAMEDE',' '.$nummer);
    }

    //$cmd = $this->app->Secure->GetPOST('cmd');
     
    //$this->app->erp->MenuEintrag('index.php?module=verbindlichkeit&action=create','Neue Verbindlichkeit anlegen');

    $this->app->erp->MenuEintrag("index.php?module=verbindlichkeit&action=edit&id=$id",'Details');
  
    $anzahldateien = $this->app->erp->AnzahlDateien('Verbindlichkeit', $id);
    if($anzahldateien > 0) {
      $anzahldateien = ' ('. $anzahldateien .')';
    } else {
      $anzahldateien='';
    }

    $this->app->erp->MenuEintrag("index.php?module=verbindlichkeit&action=dateien&id=$id",'Dateien'.$anzahldateien);

    $this->app->erp->RunMenuHook('verbindlichkeit');
  }

  function VerbindlichkeitenCreate()
  {
    $this->VerbindlichkeitenMenu();
    parent::VerbindlichkeitenCreate();
  }


  /**
   * Get all paramters from html form and save into $input
   */
  public function GetInput(): array {
      $input = array();
      //$input['EMAIL'] = $this->app->Secure->GetPOST('email');
      
      $input['rechnung'] = $this->app->Secure->GetPOST('rechnung');


      $input['rechnungsdatum'] = $this->app->Secure->GetPOST('rechnungsdatum');

      error_log("My_verbinlichkeiten::GetInput input['rechnungsdatum']:: '".
        $input['rechnungsdatum']."'",0);

      $input['betragbezahlt'] = $this->app->Secure->GetPOST('betragbezahlt');


      $input['lieferantennummer'] = $this->app->Secure->GetPOST('lieferantennummer');

      return $input;
  }

  /*
   * Set all fields in the page corresponding to $input
   */
  function SetInput($input) {
      // $this->app->Tpl->Set('EMAIL', $input['email']);        
      
      $this->app->Tpl->Set('RECHNUNG', $input['rechnung']);
      $this->app->Tpl->Set('RECHNUNGSDATUM', $input['rechnungsdatum']);
      $this->app->Tpl->Set('BETRAGBEZAHLT', $input['betragbezahlt']);
      
  }


  public function VerbindlichkeitEditable()
  {
    error_log("Verbindlichkeit:VerbindlichkeitEditable()",0);
    $this->app->YUI->AARLGEditable();
  }

  public function VerbindlichkeitPositionen() {

  error_log("Verbindlichkeit:VerbindlichkeitPositionen()",0);
    //???
    $id = $this->app->Secure->GetGET('id');

    //$this->app->erp->VerbindlichkeitNeuberechnen($id);
    $this->app->YUI->AARLGPositionen(false);
  }

  function VerbindlichkeitenEdit() {

    $id = $this->app->Secure->GetGET('id');

    $this->app->Tpl->Set('ID', $id);

    $this->app->erp->MenuEintrag("index.php?module=verbindlichkeit&action=edit&id=$id", "Details");
    $this->app->erp->MenuEintrag("index.php?module=verbindlichkeit&action=list", "Zur&uuml;ck zur &Uuml;bersicht");


    //id ist die Nummer der Verbindlichkeit
    $anzahldateien = $this->app->erp->AnzahlDateien('Verbindlichkeit',$id);
    if($anzahldateien > 0) {
      $anzahldateien = ' ('.$anzahldateien .')';
    } else {
      $anzahldateien='';
    }

    $this->app->erp->MenuEintrag("index.php?module=verbindlichkeit&action=dateien&id=$id",'Dateien'.$anzahldateien);

    // Wiederholung: bisher unklar ob Auswirkung
    $id = $this->app->Secure->GetGET('id');
    //$lieferantennummer = $this->app->Secure->GetGET('lieferantennummer');

    $input = $this->GetInput();

    foreach ($input as $key => $value) {
        echo($key." -> ".$value."<br>\n");
    }

    $submit = $this->app->Secure->GetPOST('submit');
            

    if (empty($id)) {
        // New item
        $id = 'NULL';
    } 

    if ($submit != '')
    {


        if (empty($input['rechnungsdatum'])) {
          $input['rechnungsdatum'] = date("Y-m-d");
        } else {
          $input['rechnungsdatum'] = $this->app->erp->ReplaceDatum(true,$input['rechnungsdatum'],true);
        }

        // Write to database
        
        // Add checks here

        $columns = "id, ";
        $values = "$id, ";
        $update = "";

        $fix = "";

        foreach ($input as $key => $value) {
            $columns = $columns.$fix.$key;
            $values = $values.$fix."'".$value."'";
            $update = $update.$fix.$key." = '$value'";

            $fix = ", ";
        }

            echo($columns."<br>");
            echo($values."<br>");
            echo($update."<br>");

        //$sql = "INSERT INTO verbindlichkeit (".$columns.") VALUES (".$values.") ON DUPLICATE KEY UPDATE ".$update;

        $sql = 
          "INSERT INTO verbindlichkeit ".
            "(id, rechnung, rechnungsdatum, betragbezahlt, adresse) ".
            "SELECT ".
              $id.", ".
              "'". $input['rechnung']."', ".
              "'". $input['rechnungsdatum']."', ".
              "'". $input['betragbezahlt']."', ".
              "a.id ".
            "FROM adresse a ".
            "WHERE a.lieferantennummer = '".$input[lieferantennummer]."' ".
            "ON DUPLICATE KEY UPDATE ".
              "rechnung = '". $input['rechnung'] ."', ".
              "rechnungsdatum = '".  $input['rechnungsdatum'] ."', ".
              "betragbezahlt = '".  $input['betragbezahlt'] ."', ".
              "adresse = a.id";

        echo($sql);

        $this->app->DB->Update($sql);

        if ($id == 'NULL') {
            $msg = $this->app->erp->base64_url_encode("<div class=\"success\">Das Element wurde erfolgreich angelegt.</div>");
            header("Location: index.php?module=verbindlichkeit&action=list&msg=$msg");
        } else {
            $this->app->Tpl->Set('MESSAGE', "<div class=\"success\">Die Einstellungen wurden erfolgreich &uuml;bernommen.</div>");
        }
    }


    // Load values again from database
    //$result = $this->app->DB->SelectArr("SELECT SQL_CALC_FOUND_ROWS v.id, v.rechnung, v.rechnungsdatum, v.betragbezahlt, v.id FROM verbindlichkeit v"." WHERE id=$id");

    //$result = $this->app->DB->SelectArr("SELECT SQL_CALC_FOUND_ROWS v.id, a.name, v.rechnung, DATE_FORMAT(v.rechnungsdatum,'%d.%m.%Y'), v.betragbezahlt, v.id FROM verbindlichkeit v LEFT JOIN projekt p ON v.projekt = p.id LEFT JOIN adresse a ON v.adresse = a.id WHERE v.id=$id");

    //$result = $this->app->DB->SelectArr("SELECT SQL_CALC_FOUND_ROWS v.id, a.lieferantennummer, v.rechnung, DATE_FORMAT(v.rechnungsdatum,'%d.%m.%Y'), v.betragbezahlt, v.id FROM verbindlichkeit v LEFT JOIN projekt p ON v.projekt = p.id LEFT JOIN adresse a ON v.adresse = a.id WHERE v.id=$id");

    $result = $this->app->DB->SelectArr("SELECT SQL_CALC_FOUND_ROWS v.id, a.lieferantennummer, v.rechnung, v.rechnungsdatum, v.betragbezahlt, v.id FROM verbindlichkeit v LEFT JOIN projekt p ON v.projekt = p.id LEFT JOIN adresse a ON v.adresse = a.id WHERE v.id=$id");

    foreach ($result[0] as $key => $value) {
      if($key == 'rechnungsdatum'){
        $this->app->Tpl->Set(strtoupper($key), 
          $this->app->erp->ReplaceDatum(
            false,
            $value,
            true));
      }else{
        $this->app->Tpl->Set(strtoupper($key), $value);   
        error_log("Verbindlichkeit::VerbindlichkeitenEdit strtoupper(key):: '".strtoupper($key).  "'",0);
        error_log("Verbindlichkeit::VerbindlichkeitenEdit value:: '$value'",0);
      }
    }
         
    /*
     * Add displayed items later
     * 

    $this->app->Tpl->Add('KURZUEBERSCHRIFT2', $email);
    $this->app->Tpl->Add('EMAIL', $email);
    $this->app->Tpl->Add('ANGEZEIGTERNAME', $angezeigtername);         
     */

//        $this->SetInput($input);              
    //$this->app->Tpl->Parse('PAGE', "verbindlichkeit_edit.tpl");
      error_log("Verbindlichkeit::VerbindlichkeitenEdit: 'vor TableSearch'",0);
    //$this->app->YUI->AutoComplete("kundennummer", "kunde", 1);
    //???
    $this->app->YUI->AutoComplete("lieferantennummer", "lieferant", 1);

    $this->app->YUI->DatePicker("rechnungsdatum");
    //$this->app->YUI->TableSearch('MY_VERBINDLICHKEITEN_POSITION','my_positionen_list', "show","","",basename(__FILE__), __CLASS__);


    //$this->app->YUI->AARLGPositionen(false);//???
    $this->app->YUI->AARLGPositionen();//???

    $this->app->Tpl->Parse('PAGE', "verbindlichkeit_edit.tpl");

    //$this->VerbindlichkeitenMenu();
    //parent::VerbindlichkeitenEdit();
  }

}
